/**
 * linkStates-objekte speichern in einer hashMap zu jedem knoten eine
 * hashMap, die zu jedem knoten die distanz enthaelt
 * etwa so:
 * a, ( (a,0), (b,4), (c,2), (d,1000000) )
 * b, ( (a,4), (b,0), (c,3), (d,1) )
 * usw.
 * */
package dijkstra;

import java.util.HashMap;
import java.util.Set;

class LinkStates {

    HashMap<String, HashMap> matrix;
    HashMap<String, Integer> zeile;
//link-state hinzufuegen:

    public void addLinkState(String startKnoten, String nachbar, int distanz) {
        if (matrix == null) {
            matrix = new HashMap();
        }

        if (matrix.containsKey(startKnoten)) {
            zeile = matrix.get(startKnoten);
        } else {
            zeile = new HashMap();
            matrix.put(startKnoten, zeile);
        }

        zeile.put(nachbar, distanz);

    }

    public Set<String> getNachbarn(String knoten) {
        return matrix.get(knoten).keySet();
    }

//    public Set<String> getAlleKnoten() {
////vervollstaendigen
//    }
//
//    public int getDistanz(String u, String v) {
////vervollstaendigen
//    }
    public void matrixDrucken() {
        System.out.println("Link-States: \n" + matrix.toString());
    }

    public LinkStates() {
        this.addLinkState("a", "b", 4);
        this.addLinkState("b", "a", 4);
        this.addLinkState("b", "c", 3);
        this.addLinkState("b", "d", 1);
        this.addLinkState("a", "c", 2);
        this.addLinkState("c", "a", 2);
        this.addLinkState("c", "b", 1);
        this.addLinkState("c", "d", 5);
        this.addLinkState("d", "b", 1);
        this.addLinkState("d", "c", 5);
        this.matrixDrucken();
        Set<String> knotenListe = matrix.keySet();
        for (String knoten : knotenListe) {
            System.out.printf("Nachbarn von %s: %s\n", knoten, this.getNachbarn(knoten));            
        }

    }

    public static void main(String[] args) {
        new LinkStates();
    }
}
